#!/usr/bin/perl

use strict;
use warnings;

####
my $protID_list = "idList_xenopus.txt";
my $gtf_DB      = "Xenopus_tropicalis.gtf";
####

open(GTFLINES,"$gtf_DB") or die "Cannot open $gtf_DB.¥n";
my @gtfLines = <GTFLINES>;
close GTFLINES;

my $counter = 0;
open(IDLIST, "$protID_list");
while(my $protID = <IDLIST>){
  $counter++;
  chomp($protID);
  
  my $geneID  = &geneIDpicker($protID);
  my $exonNum = &exonNumPicker($geneID);

  print "$counter $protID $geneID $exonNum\n";

}
close IDLIST;

#####

sub geneIDpicker {
  my($idSR) = @_;
  my $geneIDsr = "";
  if(my @hits = grep(/$idSR/, @gtfLines)){
    $hits[0] =~ /gene_id "(.*?)"/;
    $geneIDsr = $1;
  } else {
    $geneIDsr = "NONE";  
  }
  return($geneIDsr);
}

sub exonNumPicker{
  my($geneIDsr2) = @_;

  if($geneIDsr2 eq "NONE"){
    return("NONE");
  }

  my @hitsSR = grep(/$geneIDsr2/, @gtfLines);  
  my @numExons = ( );
  foreach my $hit (@hitsSR) {
    my $exonNumTMP = 0;
    if($hit =~ /exon_number "(\d+)"/) {
      $exonNumTMP = $1;
    }
    push(@numExons, $exonNumTMP);
  }
  my @sortExonNums = sort{$b <=> $a}@numExons;
  my $numExon = $sortExonNums[0];
  return($numExon);
}